package cz.muni.fi.pb162.exceptions;

/**
 * Tato trida reprezentuje nejakou zpravu pro konkretniho prijemce.
 *
 * @author Tomas Pitner
 * @author Petr Adamek
 */
public class Message {
    
    private String text;
    private String target;
    
    /**
     * Vytvori novou zpravu se zadanym textem urcenou pro daneho prijemce.
     *
     * @param text text zpravy
     * @param target adresa prijemce
     */
    public Message(String text, String target) {
	this.text = text;
	this.target = target;
    }
    
    /**
     * Metoda vrati text zpravy.
     *
     * @return vrati text zpravy
     */
    public String getText() {
	return text;
    }
    
    /**
     * Metoda vrati adresu prijemce zpravy.
     *
     * @return adresu prijemce zpravy
     */
    public String getTarget() {
	return target;
    }
    
    /**
     * Vrati retezec obsahujici popis zpravy.
     *
     * @return retezec obsahujici popis zpravy
     */
    public String toString() {
	return "Message for " + target + ": " + text;
    }
}
